#include "EncryptedPak.h"
FORCEINLINE BYTE _EN(BYTE v)
{
	v = (v & 0b10101010) >> 1 | (v & 0b01010101) << 1;
	return ((v & 0b11110000) >> 4) | ((v & 0b00001111) << 4);
}
FORCEINLINE BYTE _DE(BYTE v)
{
	v = (v & 0b01010101) << 1 | (v & 0b10101010) >> 1;
	return ((v & 0b11110000) >> 4) | ((v & 0b00001111) << 4);
}
template<typename T>
FORCEINLINE void _ENS(T& v)
{
	BYTE* tmp = (BYTE*)&v;
	for (int i = 0; i < sizeof(T); i++)
	{
		tmp[i] = _EN(tmp[i]);
	}
}
template<typename T>
FORCEINLINE void _DES(T& v)
{
	BYTE* tmp = (BYTE*)&v;
	for (int i = 0; i < sizeof(T); i++)
	{
		tmp[i] = _DE(tmp[i]);
	}
}
void PakEncrypt(DataPack& input, std::string key)
{
	if (input.Value.size() > 0)
	{
		std::reverse(input.Value.begin(), input.Value.end());
		for (int i = 0; i < input.Value.size(); i++)
		{
			BYTE k = (BYTE)key[i % key.size()];
			input.Value[i] = _EN(input.Value[i] ^ k);
		}
	}
	if (input.Id.size() > 0)
	{
		std::reverse(input.Id.begin(), input.Id.end());
		for (int i = 0; i < input.Id.size(); i++)
		{
			BYTE k = (BYTE)key[i % key.size()];
			input.Id[i] = _EN(input.Id[i] ^ k);
		}
	}
	for (auto& v : input.Child)
	{
		PakEncrypt(v, key);
	}
}
void PakDecrypt(DataPack& input, std::string key)
{
	if (input.Value.size() > 0)
	{
		for (int i = 0; i < input.Value.size(); i++)
		{
			BYTE k = (BYTE)key[i % key.size()];
			input.Value[i] = _DE(input.Value[i]) ^ k;
		}
		std::reverse(input.Value.begin(), input.Value.end());
	}
	if (input.Id.size() > 0)
	{
		for (int i = 0; i < input.Id.size(); i++)
		{
			BYTE k = (BYTE)key[i % key.size()];
			input.Id[i] = _DE(input.Id[i]) ^ k;
		}
		std::reverse(input.Id.begin(), input.Id.end());
	}
	for (auto& v : input.Child)
	{
		PakDecrypt(v, key);
	}
}
/*
curl http://localhost:11434/api/generate -d "{"model": "llama3","prompt": "Why is the sky blue?"}"
curl http://localhost:11434/api/generate?model="llama3.1"&prompt="Why is the sky blue?"
*/